=begin
(c) TIG 2009

explode_all_groups.rb

A script that Explodes ALL Groups in your Model.
It Explodes down to the lowest levels, including inside Components, 
by iterating through Definitions until there are no Groups left, 
trapping Groups inside Groups being exploded, also traps for multiple 
instances of same Group glitch; BUT it does not Explode any Components 
themselves.

Use with care and save your Model before using...

To use - open the Ruby Console and type 'explode_all_groups'

=end
require 'sketchup.rb'
def explode_all_groups()
  defns=Sketchup.active_model.definitions
  defns.each{|defn|
    defns.length.times do |this|
      Sketchup.active_model.definitions.each{|d|d.instances.each{|e|e.explode if e.valid?}if d.valid? and d.group?}
    end#times
  }#end each
end#def
###
